Subject: Re: Virtual FTP with only one IP?

From: Jeremy Hansen <[email-masked]>
Date: Tue, 23 Dec 1997 14:28:36 -0500

Great.  Well it sounds possible from your decussion.  If anyone
is working on this, I'd be MORE then happen to test it on a live
system.

Thanks
-jeremy

> Ken Landfield writes:
> > on the IP address to where the connection is made.  httpd has the
> > benefit of being able to read the URL supplied after the connection
> > is made. It can check if the hostname in the URL requested matches
> > one of the configured virtual hosts and then respond accordingly.
> 
>   To be nitpickingly precise, the HTTP client uses the HTTP 'host'
> command to tell the server that it expects to use the virtual server
> associated with that domain name. This was one of the changes required
> in the HTTP protocol to support virtual WWW-servers.
> 
> > The FTP protocol has no capability at present to pass that type of
> > information on initial connection.
> 
>   It could easily be added, just as WU-FTP supports a number of non RFC959
> commands. One possibility would be to use:
> 
>         XHOST domain-name
> 
> once per session, and sufficiently early in the session. It requires
> that FTP clients are changed to send an XHOST-command just before user
> authentication, assuming passwords may be managed per virtual domain. This
> modification is trivial for clients where the source code is available.
> 
>   There are no apparent drawbacks - old clients still work with
> XHOST-servers, and new clients can use the command status to decide
> if XHOST is supported at the server end or not. If it isn't, the best
> course of action is probably to ignore the error message -- that would
> make the FTP session look exactly the same as an non-XHOSTed FTP session
> with the same CNAMED host.
> 
>   Another possibility is to check if the hostname is a CNAME. If so,
> use XHOST. If not, don't, as there can be no virtual domains there.
> I don't see this is  major improvement, but it might help making error
> messages at the client end more detailed.
> 
>   Using 'SITE HOST domain' instead of XHOST is another possibility,
> and somewhat neater, as SITE is in RFC 959.
> 
>   The only problem seem to get the appropriate change made to the FTP
> clients. If the extension can be demonstrated to work with UNIX-clients,
> I rather suspect it wouldn't be too difficult to convince other FTP
> client makers to make the change.
> 
> Anders Thulin       [email-masked]        013-23 55 32
> Telia Engineering AB, Teknikringen 6, S-583 30 Linkoping, Sweden

---

From: Jesse Schachter <[email-masked]>
Date: Tue, 23 Dec 1997 15:02:48 -0500 (EST)

> > commands. One possibility would be to use:

Jeremy, you are understanding that in order for this to work, not only 
would the wu-ftp server need to be modified, but everyone in the world 
would need to pick up an ftp client which supports non ip based virtual 
hosting :-)

-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-
      Jesse Schachter                -=+=- Work   - (203) 619-0800
      [email-masked]            -=+=- Direct - (203) 619-0822
        MicroNet System Administration/Unix Software Engineering
	   Q: When driving through fog, what should you use?
	   A: Your car.
-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-\-/-

---

From: Jeremy Hansen <[email-masked]>
Date: Tue, 23 Dec 1997 15:15:01 -0500

I understand that people would have to change there client,
which actually I believe wouldn't be that bad of a deal. 
Standards have changed before, which basically left people
broken, and people finally decided to update their software to
take advantage of new features.

Besides, from the discussion, I got the impression that
there would be a way around compatibility issues.  A feature
like this would be far to useful to be held back by client
limitations.  

Don't you think an advantage like this would be more then
accepted and supported by system administrators and users?

Perhaps I'm wrong, but this same thing happened in the
httpd world, why can't it happen in ftpd world?

-jeremy

---

From: Jesse Schachter <[email-masked]>
Date: Tue, 23 Dec 1997 15:36:59 -0500 (EST)

> httpd world, why can't it happen in ftpd world?

Web clients are an industry controlled product. They are constantly 
changing and coming out with new features, and people accept the fact 
that they need to upgrade their browser every few months. FTP clients, 
however, have remained strictly rfc based. I have been using the same ftp 
client for the past few years, the one that is stock shipped with my 
operating system. However I've gone through many browsers as people start 
adding more and more proprietary crap to their web pages and make the web 
do stuff it wasn't meant to, like stream video :-) I don't know how 
feesable it would be to try and get the world to accept new ftp 
standards, you would probably need to release a new RFC for this, and 
then make a deal with microsoft to force everyone to use this new ftp 
client...

---

From: Jeremy Hansen <[email-masked]>
Date: Tue, 23 Dec 1997 15:54:07 -0500

I see what your saying.  My question is then...does the
effort it would take to implement a working server/client
outweigh its worth?

Although you may be right about people's unwillingness to change
clients, I would in turn tell my user's that they MUST use this
client to reach certain site within my control.

As far as differences in clients, it depends on what your using.
For example at work (my real job) I'm forced to use the ftp client
present in the Solaris 2.5.1 distro, which I feel seriously lacks
in capability and features.

At home (where I get work done) I use  RH Linux, which has many features
over Solaris's distro.  Complete Solaris's full distro's do not come out
that often, but on the other hand, you'll find new versions of RH like
every 4 - 6 months, which would make it very simple to distribute a new
client.

Plus, I think a multi-platform virtual ftp client would be very
marketable.
Just look at what f-secure did with ssh.  

All I'm saying is, what would it take to make it available to those who
want to use it?

-jeremy

> I don't know how

---

From: Kent Landfield <[email-masked]>
Date: Tue, 23 Dec 1997 15:54:10 -0600 (CST)

# 
# Great.  Well it sounds possible from your decussion.  If anyone
# is working on this, I'd be MORE then happen to test it on a live
# system.
# 
# Thanks
# -jeremy

Jeremy,

Anders Thulin <[email-masked]> and I are going to be submitting an
Internet Draft to the IETF's FTPEXT working group.  It will take a bit before
we are ready to test a prototype.  I like the attitude though. ;)  

And just as a heads up... There is now an effort to start an Apache-like
development process up.  It is happening as I type.  We will have things
setup shortly.  This should start breathing new life into FTP clients and
server software.  This is one of the areas that will be prototyped.

We will be needing lots of testers ;)

-- 
Kent Landfield                        Phone: 1-817-545-2502             
Email: [email-masked]             http://www.landfield.com/
Email: [email-masked]                   http://www.nfr.net/
Please send comp.sources.misc related mail to [email-masked]
Search the Usenet Hypertext FAQ Archive at http://www.faqs.org/faqs/

---

From: XxEDGExX <[email-masked]>
Date: Tue, 23 Dec 1997 17:00:27 -0500 (EST)

Wonderful.  Put me on the list.  As soon as something
is available I'd like to be notified.

Thank you!
-jeremy

># 
># Great.  Well it sounds possible from your discussion.  If anyone
>Email: [email-masked]             http://www..landfield.com/

http://www.xxedgexx.com | [email-masked]
 _  _     _     _   _   | pgp available from:
 _|  |    _| | |_  | |  | http://www.xxedgexx.com/pgp.html
|_   | o |_  |  _| |_|  |

---

From: [email-masked] (Daniel Rubin)
Date: Tue, 23 Dec 1997 17:45:50 -0800

> effort it would take to implement a working server/client

I would have to say this feature is a must in todays Internet
driven world.  With the HTML standard supporting "virtual"
hosting through one IP most presence providers are using
this method because it helps to better preserve precious
IP addresses.  Unfortunatly, ftp currently does not fit in
well with this senerio.  Considering ftp and HTTP are being
used side by side in many applications I believe they should
compliment each other not interfere with each other.

IMHO this feature needs to be included to keep ftp up with
what is going on with the Internet today and is well worth
the development and testing effort.

    - Dan

--
Daniel Rubin, (614) 457-5919               - Internet Consulting
President, Newcoast Communications, Inc.   - System & Network
                                             Planning & Administration
[email-masked] http://www.newcoast.com   - Internet Services